# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetConfigServerResult',
    'AwaitableGetConfigServerResult',
    'get_config_server',
    'get_config_server_output',
]

warnings.warn("""azure-native:appplatform/v20201101preview:ConfigServer is being removed in the next major version of this provider. Upgrade to at least azure-native:appplatform/v20230501preview:ConfigServer to guarantee forwards compatibility.""", DeprecationWarning)

@pulumi.output_type
class GetConfigServerResult:
    """
    Config Server resource
    """
    def __init__(__self__, id=None, name=None, properties=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Fully qualified resource Id for the resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.ConfigServerPropertiesResponse':
        """
        Properties of the Config Server resource
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource.
        """
        return pulumi.get(self, "type")


class AwaitableGetConfigServerResult(GetConfigServerResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConfigServerResult(
            id=self.id,
            name=self.name,
            properties=self.properties,
            type=self.type)


def get_config_server(resource_group_name: Optional[str] = None,
                      service_name: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConfigServerResult:
    """
    Get the config server and its properties.


    :param str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param str service_name: The name of the Service resource.
    """
    pulumi.log.warn("""get_config_server is deprecated: azure-native:appplatform/v20201101preview:ConfigServer is being removed in the next major version of this provider. Upgrade to at least azure-native:appplatform/v20230501preview:ConfigServer to guarantee forwards compatibility.""")
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:appplatform/v20201101preview:getConfigServer', __args__, opts=opts, typ=GetConfigServerResult).value

    return AwaitableGetConfigServerResult(
        id=__ret__.id,
        name=__ret__.name,
        properties=__ret__.properties,
        type=__ret__.type)


@_utilities.lift_output_func(get_config_server)
def get_config_server_output(resource_group_name: Optional[pulumi.Input[str]] = None,
                             service_name: Optional[pulumi.Input[str]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetConfigServerResult]:
    """
    Get the config server and its properties.


    :param str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param str service_name: The name of the Service resource.
    """
    pulumi.log.warn("""get_config_server is deprecated: azure-native:appplatform/v20201101preview:ConfigServer is being removed in the next major version of this provider. Upgrade to at least azure-native:appplatform/v20230501preview:ConfigServer to guarantee forwards compatibility.""")
    ...
