# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'GetAppResult',
    'AwaitableGetAppResult',
    'get_app',
    'get_app_output',
]

warnings.warn("""Version 2018-09-01 will be removed in v2 of the provider.""", DeprecationWarning)

@pulumi.output_type
class GetAppResult:
    """
    The IoT Central application.
    """
    def __init__(__self__, application_id=None, display_name=None, geography=None, id=None, location=None, name=None, sku=None, state=None, subdomain=None, tags=None, template=None, tenant=None, thumbnail_url=None, type=None):
        if application_id and not isinstance(application_id, str):
            raise TypeError("Expected argument 'application_id' to be a str")
        pulumi.set(__self__, "application_id", application_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if geography and not isinstance(geography, str):
            raise TypeError("Expected argument 'geography' to be a str")
        pulumi.set(__self__, "geography", geography)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if sku and not isinstance(sku, dict):
            raise TypeError("Expected argument 'sku' to be a dict")
        pulumi.set(__self__, "sku", sku)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)
        if subdomain and not isinstance(subdomain, str):
            raise TypeError("Expected argument 'subdomain' to be a str")
        pulumi.set(__self__, "subdomain", subdomain)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if template and not isinstance(template, str):
            raise TypeError("Expected argument 'template' to be a str")
        pulumi.set(__self__, "template", template)
        if tenant and not isinstance(tenant, str):
            raise TypeError("Expected argument 'tenant' to be a str")
        pulumi.set(__self__, "tenant", tenant)
        if thumbnail_url and not isinstance(thumbnail_url, str):
            raise TypeError("Expected argument 'thumbnail_url' to be a str")
        pulumi.set(__self__, "thumbnail_url", thumbnail_url)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> str:
        """
        The ID of the application.
        """
        return pulumi.get(self, "application_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[str]:
        """
        The display name of the application.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def geography(self) -> str:
        """
        The geography the application is in.
        """
        return pulumi.get(self, "geography")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ARM resource identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        The resource location.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The ARM resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def sku(self) -> 'outputs.AppSkuInfoResponse':
        """
        A valid instance SKU.
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        The current state of the application.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def subdomain(self) -> Optional[str]:
        """
        The subdomain of the application.
        """
        return pulumi.get(self, "subdomain")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        The resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def template(self) -> Optional[str]:
        """
        The ID of the application template, which is a blueprint that defines the characteristics and behaviors of an application. Optional; if not specified, defaults to a blank blueprint and allows the application to be defined from scratch.
        """
        return pulumi.get(self, "template")

    @property
    @pulumi.getter
    def tenant(self) -> str:
        """
        The tenant ID the application belongs to.
        """
        return pulumi.get(self, "tenant")

    @property
    @pulumi.getter(name="thumbnailUrl")
    def thumbnail_url(self) -> str:
        """
        The URI for the thumbnail image used in the application.
        """
        return pulumi.get(self, "thumbnail_url")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetAppResult(GetAppResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppResult(
            application_id=self.application_id,
            display_name=self.display_name,
            geography=self.geography,
            id=self.id,
            location=self.location,
            name=self.name,
            sku=self.sku,
            state=self.state,
            subdomain=self.subdomain,
            tags=self.tags,
            template=self.template,
            tenant=self.tenant,
            thumbnail_url=self.thumbnail_url,
            type=self.type)


def get_app(resource_group_name: Optional[str] = None,
            resource_name: Optional[str] = None,
            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppResult:
    """
    Get the metadata of an IoT Central application.


    :param str resource_group_name: The name of the resource group that contains the IoT Central application.
    :param str resource_name: The ARM resource name of the IoT Central application.
    """
    pulumi.log.warn("""get_app is deprecated: Version 2018-09-01 will be removed in v2 of the provider.""")
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:iotcentral/v20180901:getApp', __args__, opts=opts, typ=GetAppResult).value

    return AwaitableGetAppResult(
        application_id=__ret__.application_id,
        display_name=__ret__.display_name,
        geography=__ret__.geography,
        id=__ret__.id,
        location=__ret__.location,
        name=__ret__.name,
        sku=__ret__.sku,
        state=__ret__.state,
        subdomain=__ret__.subdomain,
        tags=__ret__.tags,
        template=__ret__.template,
        tenant=__ret__.tenant,
        thumbnail_url=__ret__.thumbnail_url,
        type=__ret__.type)


@_utilities.lift_output_func(get_app)
def get_app_output(resource_group_name: Optional[pulumi.Input[str]] = None,
                   resource_name: Optional[pulumi.Input[str]] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAppResult]:
    """
    Get the metadata of an IoT Central application.


    :param str resource_group_name: The name of the resource group that contains the IoT Central application.
    :param str resource_name: The ARM resource name of the IoT Central application.
    """
    pulumi.log.warn("""get_app is deprecated: Version 2018-09-01 will be removed in v2 of the provider.""")
    ...
